Description

The IssueRelationTest#test_create_with_initialized_journals test fails randomly with the following error:

Failure:  

IssueRelationTest#test_create_with_initialized_journals_should_create_journals [test/unit/issue_re

lation_test.rb:220]:  

Expected: "relation"  

  Actual: "attr"  

bin/rails test test/unit/issue_relation_test.rb:202  

 The exact reason for the random failures is unclear, but it is likely related to the order of details in to.journals.last.details.

Currently, to.journals.last.details contains three Detail entries in the following order:

1. property: 'relation', prop_key: 'follows' (expected value)

2. property: 'attr', prop_key: 'due_date'

3. property: 'attr', prop_key: 'start_date' (actual value)

As a result, to.journals.last.details.last does not match the expected Detail in the test.

This behavior appears to be correct. When an IssueRelation with a "precedes" type is created, the handle_issue_order callback

updates the due_date and start_date of the related issue. These updates are recorded in the journal, resulting in additional Detail

entries.

I have attached the patch for updating the test to verify the presence of the expected Detail without relying on the order. Additionally,

the patch includes assertions to ensure that to.journals.last.details contains changes to due_date and start_date.

diff --git a/test/unit/issue_relation_test.rb b/test/unit/issue_relation_test.rb

index a223fe42c..198dd94ad 100644

--- a/test/unit/issue_relation_test.rb

+++ b/test/unit/issue_relation_test.rb

@@ -202,25 +202,27 @@ class IssueRelationTest < ActiveSupport::TestCase

   def test_create_with_initialized_journals_should_create_journals

     from = Issue.find(1)

     to   = Issue.find(2)

-    from_journals = from.journals.size

-    to_journals   = to.journals.size

     relation = IssueRelation.new(:issue_from => from, :issue_to => to,

                                  :relation_type => IssueRelation::TYPE_PRECEDES)

     relation.init_journals User.find(1)

-    assert relation.save

-    from.reload

-    to.reload

-    relation.reload

-    assert_equal from.journals.size, (from_journals + 1)

-    assert_equal to.journals.size, (to_journals + 1)

-    assert_equal 'relation', from.journals.last.details.last.property

-    assert_equal 'precedes', from.journals.last.details.last.prop_key

-    assert_equal '2', from.journals.last.details.last.value

-    assert_nil   from.journals.last.details.last.old_value

2025-04-01 1/2

https://github.com/redmine/redmine/blob/9c5199f5f5d7f5c52f6dce5a5f0ebd707cc30289/app/models/issue_relation.rb#L186-L192


-    assert_equal 'relation', to.journals.last.details.last.property

-    assert_equal 'follows', to.journals.last.details.last.prop_key

-    assert_equal '1', to.journals.last.details.last.value

-    assert_nil   to.journals.last.details.last.old_value

+

+    assert_difference(

+      ->{ from.reload.journals.size } => +1,

+      ->{ to.reload.journals.size } => +1

+    ) do

+      assert relation.save

+    end

+

+    from.journals.last.details.then do |details|

+      assert details.exists?(property: 'relation', prop_key: 'precedes', value: '2')

+    end

+

+    to.journals.last.details.then do |details|

+      assert_equal 3, details.count

+      assert details.exists?(property: 'relation', prop_key: 'follows', value: '1', old_value: ni

l)

+      assert details.exists?(property: 'attr', prop_key: 'due_date')

+      assert details.exists?(property: 'attr', prop_key: 'start_date')

+    end

   end

   def test_destroy_with_initialized_journals_should_create_journals

Associated revisions

Revision 23350 - 2024-12-04 02:47 - Go MAEDA

Fix random failures in IssueRelationTest#test_create_with_initialized_journals due to ambiguous conditions for retrieving the expected detail

(#41931).

Patch by Katsuya HIDAKA (user:hidakatsuya).

Revision 23355 - 2024-12-08 05:56 - Go MAEDA

Merged r23350 from trunk to 6.0-stable (#41931).

Revision 23356 - 2024-12-08 05:58 - Go MAEDA

Merged r23350 from trunk to 5.1-stable (#41931).

History

#1 - 2024-12-03 18:43 - Katsuya HIDAKA

- File 0001-Fix-random-failures-in-IssueRelationTest-test_create_with_initialized_journals-due-to-ambiguous-expected-detail-retr.patch added

#2 - 2024-12-04 02:32 - Go MAEDA

- Target version set to 5.1.5

#3 - 2024-12-04 02:48 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

Committed the fix in r23350. Thank you.

#4 - 2024-12-08 05:58 - Go MAEDA

- Status changed from Resolved to Closed

Merged the fix into the stable branches in r23355 and r23356.

Files

0001-Fix-random-failures-in-IssueRelationTest-test_create_with_initialized_journals-due-to-ambiguous-expected-detail-retr.patch2.46 KB 2024-12-03 Katsuya HIDAKA
